<?php
#############################################################################
#                                                                           #
# GXRoute Version 0.1 beta 5                                                #
# Copyright 2008 Gerd Xhonneux                                              #
# http://xtc.xhonneux.com                                                   #
#                                                                           #
# This is a modified and enhanced version of original                       #
# "Google Maps mit Straenverbindungen":                                    #
# Thomas Weise                                                              #
#	Dr. Web                                                                   #
#	http://www.drweb.de                                                       #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA   #
#                                                                           #
#############################################################################

//error_reporting(E_ALL);

function gxroute($nMapNum) {
  GLOBAL $plugin_tx,$plugin_cf,$pth, $plugin, $sl;

$gxroute_version = "0.1 beta 5";
$gxroute_plugin       = basename(dirname(__FILE__),'/');
$gxroute_pluginfolder = $pth['folder']['plugins'].$gxroute_plugin;         # folder where the plugin resides

$tmp .= "<!-- Code start - inserted by GXRoute ".$gxroute_version." from http://xtc.xhonneux.com -->\r\n";
$tmp .= "<div id=\"GXRoute\">";

$plugin = basename(dirname(__FILE__), "/");

if (!isset($nMapNum)) {
  $nMapNum = 0;
} else {
  $nMapNum -=1;
}

//Map and alternate domain / API keys arrays
$aposition_latitude = explode($plugin_cf['gxroute']['delimiter'],$plugin_cf['gxroute']['position_latitude']);
$aposition_longitude = explode($plugin_cf['gxroute']['delimiter'],$plugin_cf['gxroute']['position_longitude']);
$aaddress = explode($plugin_cf['gxroute']['delimiter'],$plugin_cf['gxroute']['address']);

$aaltdomains = explode($plugin_cf['gxroute']['delimiter'],$plugin_cf['gxroute']['alternate_Domains']);
$aaltapikeys = explode($plugin_cf['gxroute']['delimiter'],$plugin_cf['gxroute']['alternate_APIkeys']);
 
// Create Map 
foreach ($aposition_latitude as $key => $value) {
  if ($key == $nMapNum) {
   
  // Start temporary files in folder map
  $MapFolder = $gxroute_pluginfolder . "/map/";
  $MapFile = $MapFolder . "gxroute_".$key."_".$sl.".html";
  $JSFile  = "gxroute_".$key."_".$sl.".js";
  
  // Create temporary html file
 	$maptemp = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\"><html xmlns=\"http://www.w3.org/1999/xhtml\"><head><meta http-equiv=\"Content-Type\" content=\"text/html; utf-8\"/><title>Dynamically generated HTML for GXRoute ".$gxroute_version."</title>";
	$maptemp .= "<link rel=\"stylesheet\" type=\"text/css\" href=\"../css/gxroute.css\" />";
	$maptemp .= "<script type=\"text/javascript\" src=\"".$JSFile."\"></script>";
  $maptemp .= "<script type=\"text/javascript\">document.write('<script src=\"http://maps.google.com/maps?file=api&amp;v=2&amp;key='+({";
  // add for each alternate domain the domain and the alternate API key
  foreach ($aaltdomains as $nkey => $nvalue) {  
    $maptemp .= "'".$aaltdomains[$nkey]."': '".$aaltapikeys[$nkey]."'";
    // Add a comma if not the last record in array
    if ($nkey+1 < count($aaltdomains)) {
       $maptemp .= ",";
    }
  }
  $maptemp .= "}[location.host]||'".$plugin_cf['gxroute']['APIkey']."')+'\" type=\"text/javascript\"><\/script>' );</script>";
  $maptemp .= "</head>";
	$maptemp .= "<body onload=\"twGmapLoad();\" onunload=\"GUnload();\">";
	$maptemp .= "<div id=\"twGmap\">&nbsp;</div>";
	$maptemp .= "</body>";	
  $maptemp .= "</html>";	
  //write HTML file
	$fh = fopen($MapFile, 'w') or die("GXRoute: Can't open ".$MapFile." file, please check the permissions");
	fwrite($fh, $maptemp);
	fclose($fh);

  // Create temporary javascript file
 	$jstemp = "// Dynamically generated Javascript for GXRoute ".$gxroute_version."\r\n\r\n";
  $jstemp .= "var elementId = \"twGmap\";  // muss im html an ein <div> als id vergeben werden\r\n";
  $jstemp .= "var lat       = \"".$aposition_latitude[$key]."\";  // Breitengrad (Latitude) z.B: 51.041\r\n";
  $jstemp .= "var lon       = \"".$aposition_longitude[$key]."\";  // Lngengrad (Longitude) z.B: 13.748\r\n";
  $jstemp .= "var zoom      = ".$plugin_cf['gxroute']['zoomlevel'].";        // einen Wert von 1 bis ca 17\r\n";
  $jstemp .= "var directionMarkers   = [];\r\n";
  $jstemp .= "var directionHtmls     = [];\r\n";
  $jstemp .= "var directionHtmlsNach = [];\r\n";
  $jstemp .= "var directionHtmlsVon  = [];\r\n";
  $jstemp .= "var directionCount     = 0;\r\n\r\n";

  $jstemp .= "/**\r\n";
  $jstemp .= " * Prft auf kompatiblen Browser und vorhandene Variablen und ruft die\r\n";
  $jstemp .= " * Funktion auf, die die GoogleMap erstellt.\r\n";
  $jstemp .= " */\r\n";
  $jstemp .= "function twGmapLoad() {\r\n";
  $jstemp .= "	if (GBrowserIsCompatible()) {\r\n";
  $jstemp .= "		if (!document.getElementById(elementId)) {\r\n";
  $jstemp .= "			alert(\"Fehler: das Element mit der id \"+ elementId+ \" konnte nicht auf dieser Webseite gefunden werden!\");\r\n";
  $jstemp .= "			return false;\r\n";
  $jstemp .= "		} else {\r\n";
  $jstemp .= "			if (lat==\"\" || isNaN(lat)) {\r\n";
  $jstemp .= "				lat = 50.65373242;\r\n";
  $jstemp .= "				alert(\"Fehler: Der Breitengrad(lat) wurde im Skript nicht korrekt eingetragen! Ein Defaultwert wird deshalb benutzt!\");\r\n";
  $jstemp .= "			}\r\n";
  $jstemp .= "			if (lon==\"\" || isNaN(lon)) {\r\n";
  $jstemp .= "				lon = 6.05344534;\r\n";
  $jstemp .= "				alert(\"Fehler: Der Lngengrad(lon) wurde im Skript nicht korrekt eingetragen! Ein Defaultwert wird deshalb benutzt!\");\r\n";
  $jstemp .= "			}\r\n";
  $jstemp .= "			if (typeof zoom == \"undefined\") {\r\n";
  $jstemp .= "				zoom = 13;\r\n";
  $jstemp .= "				alert(\"Fehler: Die Zoomstufe wurde im Skript nicht korrekt eingetragen! Ein Defaultwert wird deshalb benutzt!\");\r\n";
  $jstemp .= "			}\r\n";
  $jstemp .= "			machTwGmap(elementId, lat, lon, zoom);\r\n";
  $jstemp .= "		}\r\n";
  $jstemp .= "	}\r\n";
  $jstemp .= "}\r\n\r\n";

  $jstemp .= "/**\r\n";
  $jstemp .= " * Erstellt die GoogleMap in dem <div>-Bereich mit der bergebenen id\r\n";
  $jstemp .= " * @param {Object} id   -im div-Bereich mit dieser id wird die Map dargestellt\r\n";
  $jstemp .= " * @param {Object} lat  -Breitengrad\r\n"; 
  $jstemp .= " * @param {Object} lon  -Lngengrad\r\n";
  $jstemp .= " * @param {Object} zoom -Zoomstufe 1 bis 17 (ganze Welt bis kleiner Ausschnitt)\r\n";
  $jstemp .= " */\r\n";
  $jstemp .= "function machTwGmap(id, lat, lon, zoom) {\r\n";
  $jstemp .= "	// die Map (fr das div mit der id=\"...\")\r\n";
  $jstemp .= "	var map = new GMap2(document.getElementById(id));\r\n";
  $jstemp .= "	// mit Zoom (auch noch: GSmallMapControl, GLargeMapControl, GSmallZoomControl, GScaleControl)\r\n";
  $jstemp .= "	map.addControl(new GSmallMapControl());\r\n";
  $jstemp .= "	// mit Typ-Auswahl (auch noch: GMapTypeControl, GHierarchicalMapTypeControl, GOverviewMapControl)\r\n";
  $jstemp .= "	map.addControl(new GMapTypeControl());\r\n";
  $jstemp .= "	// ((Breitengrad, Lngengrad), Zoomstufe, G_NORMAL_MAP/G_SATELLITE_MAP/G_HYBRID_MAP)\r\n";
  $jstemp .= "	map.setCenter(new GLatLng(lat, lon), zoom, G_HYBRID_MAP);\r\n";
  $jstemp .= "	// Marker setzen mit eigener Marker-Funktion\r\n";
  $jstemp .= "	map = setTwMarkers(map);\r\n";
  $jstemp .= "}\r\n\r\n";

  $jstemp .= "/**\r\n";
  $jstemp .= " * Erstellt alle Marker fr die bergebene Google Map.\r\n";
  $jstemp .= " * (Ruft intern fr jeden Marker eine eigene Funktion auf)\r\n";
  $jstemp .= " * @param {Object} map\r\n";
  $jstemp .= " */\r\n";
  $jstemp .= "function setTwMarkers(map) {\r\n";
  $jstemp .= "	var marker01 = machTwMarker01();\r\n";
  $jstemp .= "	///var marker02 = machTwMarker02();\r\n";
  $jstemp .= "	///var marker03 = machTwMarker03();\r\n";
  $jstemp .= "	map.addOverlay(marker01);\r\n";
  $jstemp .= "	///map.addOverlay(marker02);\r\n";
  $jstemp .= "	///map.addOverlay(marker03);\r\n";
  $jstemp .= "	return map;\r\n";
  $jstemp .= "}\r\n\r\n";

  $jstemp .= "function machTwMarker01() {\r\n";
  $jstemp .= "	var point = new GPoint(".$aposition_longitude[$key].", ".$aposition_latitude[$key].");\r\n";
  $jstemp .= "	var adresse = \"".$aaddress[$key]."\";\r\n";
  $jstemp .= "	var marker = new GMarker(point);\r\n";
  $jstemp .= "	var html = machTwHtmlInfofenster(marker, adresse);\r\n";
  $jstemp .= "	GEvent.addListener(marker, \"click\", function() {marker.openInfoWindowHtml(html)});\r\n";	
  $jstemp .= "	return marker;\r\n";
  $jstemp .= "}\r\n";
  $jstemp .= "/*\r\n";
  $jstemp .= "function machTwMarker02() {\r\n";
  $jstemp .= "	var point = new GPoint(13.732, 51.048);\r\n";
  $jstemp .= "	var marker = new GMarker(point);\r\n";
  $jstemp .= "	var html = machTwHtmlInfofenster(marker);\r\n";
  $jstemp .= "	GEvent.addListener(marker, \"click\", function() {marker.openInfoWindowHtml(html)});\r\n";
  $jstemp .= "	return marker;\r\n";
  $jstemp .= "}\r\n";
  $jstemp .= "function machTwMarker03() {\r\n";
  $jstemp .= "	var point = new GPoint(13.750, 51.049);\r\n";
  $jstemp .= "	var marker = new GMarker(point);\r\n";
  $jstemp .= "	var html = machTwHtmlInfofenster(marker);\r\n";
  $jstemp .= "	GEvent.addListener(marker, \"click\", function() {marker.openInfoWindowHtml(html)});\r\n";
  $jstemp .= "	return marker;\r\n";
  $jstemp .= "}\r\n";
  $jstemp .= "*/\r\n\r\n";

  $jstemp .= "function machTwHtmlInfofenster(marker, adresse) {\r\n";
  $jstemp .= "	var point = marker.getLatLng();\r\n";
  $jstemp .= "	directionCount++;	\r\n";
  $jstemp .= "	directionMarkers[directionCount] = marker;\r\n";
  $jstemp .= "	// das Infofenster vor der Auswahl von Start- oder Zieladresse\r\n";
  $jstemp .= "	htmlDefault = '';\r\n";
  $jstemp .= "	htmlDefault += '<div class=\"twGmapInfo\">';\r\n";
	$jstemp .= "htmlDefault += ' <p class=\"headline\">".$plugin_tx['gxroute']['jshtmlwin_title']."</p>';\r\n";
  $jstemp .= "	htmlDefault += ' <br />".$plugin_tx['gxroute']['jshtmlwin_quest1']."';\r\n";
  $jstemp .= "	htmlDefault += ' <br /><a href=\"javascript:openTwInfofensterVon('+directionCount+')\">".$plugin_tx['gxroute']['jshtmlwin_useasstart']."<\/a>';\r\n";
  $jstemp .= "	htmlDefault += ' <br /><a href=\"javascript:openTwInfofensterNach('+directionCount+')\">".$plugin_tx['gxroute']['jshtmlwin_useastarget']."<\/a>';\r\n";
  $jstemp .= "	htmlDefault += '</div>';\r\n";
  $jstemp .= "	directionHtmls[directionCount] = htmlDefault;\r\n";
  $jstemp .= "	// das Infofenster, in dem die Startadresse eingegeben werden kann\r\n";
  $jstemp .= "	htmlVon = '';\r\n";
  $jstemp .= "	htmlVon += '<div class=\"twGmapInfo\">';\r\n";
  $jstemp .= "	htmlVon += ' <p class=\"headline\">".$plugin_tx['gxroute']['jshtmlwin_title']."</p>';\r\n";
  $jstemp .= "	htmlVon += ' <p>".$plugin_tx['gxroute']['jshtmlwin_startis']."</p>';\r\n";
  $jstemp .= "	htmlVon += ' <p><input type=\"text\" size=40 maxlength=40 value=\"' + adresse + '\" readonly=\"readonly\" /></p>';\r\n";
  $jstemp .= "	htmlVon += ' <p>".$plugin_tx['gxroute']['jshtmlwin_entertarget']."</p>';\r\n";
  $jstemp .= "	htmlVon += ' <p class=\"klein\">(".$plugin_tx['gxroute']['jshtmlwin_example'].": Welkenraedt, Rue Xhonneux 1)</p>';\r\n";
  $jstemp .= "	htmlVon += ' <form action=\"http://maps.google.com/maps\" method=\"get\" target=\"_blank\">';\r\n";
  $jstemp .= "	htmlVon += '  <p><input type=\"text\" size=40 maxlength=40 name=\"daddr\" id=\"daddr\" value=\"\" tabindex=\"1\" /></p>';\r\n";
  $jstemp .= "	htmlVon += '  <p><input type=\"hidden\" name=\"saddr\" value=\"' + point.lat() + ',' + point.lng() + ' (' + adresse + ')' + '\" /></p>';\r\n";
  $jstemp .= "	htmlVon += '  <p class=\"submit\"><input value=\"".$plugin_tx['gxroute']['jshtmlwin_title']."\" type=\"submit\" /></p>';\r\n";
  $jstemp .= "	htmlVon += '  <p class=\"submit klein\">(".$plugin_tx['gxroute']['jshtmlwin_showinnewwindow'].")</p>';\r\n";
  $jstemp .= "	htmlVon += ' </form>';\r\n";
  $jstemp .= "	htmlVon += '</div>';\r\n";
  $jstemp .= "	directionHtmlsVon[directionCount] = htmlVon;\r\n";
  $jstemp .= "	// das Infofenster, in dem die Zieladresse eingegeben werden kann\r\n";
  $jstemp .= "	htmlNach = '';\r\n";
  $jstemp .= "	htmlNach += '<div class=\"twGmapInfo\">';\r\n";
  $jstemp .= "	htmlNach += ' <p class=\"headline\">".$plugin_tx['gxroute']['jshtmlwin_title']."</p>';\r\n";
  $jstemp .= "	htmlNach += ' <p>".$plugin_tx['gxroute']['jshtmlwin_targetis']."</p>';\r\n";
  $jstemp .= "	htmlNach += ' <p><input type=\"text\" size=40 maxlength=40 value=\"' + adresse + '\" readonly=\"readonly\" /></p>';\r\n";
  $jstemp .= "	htmlNach += ' <p>".$plugin_tx['gxroute']['jshtmlwin_enterstart']."</p>';\r\n";
  $jstemp .= "	htmlNach += ' <p class=\"klein\">(".$plugin_tx['gxroute']['jshtmlwin_example'].": Welkenraedt, Rue Xhonneux 1)</p>';\r\n";
  $jstemp .= "	htmlNach += ' <form action=\"http://maps.google.com/maps\" method=\"get\" target=\"_blank\">';\r\n";
  $jstemp .= "	htmlNach += '  <p><input type=\"text\" size=40 maxlength=40 name=\"saddr\" id=\"saddr\" value=\"\" /></p>';\r\n";
  $jstemp .= "	htmlNach += '  <p><input type=\"hidden\" name=\"daddr\" value=\"' + point.lat() + ',' + point.lng() + ' (' + adresse + ')' + '\" /></p>';\r\n";
  $jstemp .= "	htmlNach += '  <p class=\"submit\"><input type=\"submit\" value=\"".$plugin_tx['gxroute']['jshtmlwin_title']."\" /></p>';\r\n";
  $jstemp .= "	htmlNach += '  <p class=\"submit klein\">(".$plugin_tx['gxroute']['jshtmlwin_showinnewwindow'].")</p>';\r\n";
  $jstemp .= "	htmlNach += ' </form>';\r\n";
  $jstemp .= "	htmlNach += '</div>';\r\n";
  $jstemp .= "	directionHtmlsNach[directionCount] = htmlNach;\r\n";
  $jstemp .= "	return htmlDefault;\r\n";
  $jstemp .= "}\r\n\r\n";

  $jstemp .= "// functions that open the directions forms\r\n";
  $jstemp .= "function openTwInfofensterNach(i) {\r\n";
  $jstemp .= "	directionMarkers[i].openInfoWindowHtml(directionHtmlsNach[i]);\r\n";
  $jstemp .= "}\r\n";
  $jstemp .= "function openTwInfofensterVon(i) {\r\n";
  $jstemp .= "	directionMarkers[i].openInfoWindowHtml(directionHtmlsVon[i]);\r\n";
  $jstemp .= "}\r\n";

  //write JS file
  $fh = fopen($MapFolder.$JSFile, 'w') or die("GXRoute: Can't open ".$MapFolder.$JSFile." file, please check the permissions");
  fwrite($fh, $jstemp);
	fclose($fh);
  // End of manipulating temporary files in folder map
   
  }
}



$tmp .= "<table align=\"".$plugin_cf['gxroute']['align']."\" border=0><tr><td><div align=\"".$plugin_cf['gxroute']['align']."\"><iframe align=\"".$plugin_cf['gxroute']['align']."\" width=\"".$plugin_cf['gxroute']['mapsize_width']."\" height=\"".$plugin_cf['gxroute']['mapsize_height']."\" frameborder=\"0\" src=\"".$MapFile."\">"."http://".$_SERVER['HTTP_HOST'].substr($MapFile,1)."</iframe></div></td></tr></table>";

$tmp .= "</div>";
$tmp .= "<!-- Code end - inserted by GXRoute ".$gxroute_version." from http://xtc.xhonneux.com -->\r\n"; 

// Back to CMSimple
return($tmp);
}
?>
